<template>
  <background class="row justify-center">
    <q-card class="col-lg-8 col-md-10 col-sm-12 col-xs-12">
      <q-splitter
        v-model="splitterModel"
        :horizontal="$q.screen.lt.sm"
        :limits="[9, 20]"
      >
        <template #before>
          <q-tabs
            v-model="tab"
            :vertical="!$q.screen.lt.sm"
            class="text-teal"
          >
            <q-tab
              name="journey"
              icon="timeline"
              label="Jízdy"
            />
            <q-tab
              name="timetable"
              icon="directions_transit_filled"
              label="Jízdní řády"
            />
            <q-tab
              name="planner"
              icon="schedule"
              label="Plánování"
            />
          </q-tabs>
        </template>

        <template #after>
          <q-tab-panels
            v-model="tab"
            animated
            swipeable
            vertical
            transition-prev="jump-up"
            transition-next="jump-up"
          >
            <q-tab-panel
              name="journey"
            >
              <journey ref="journey" />
            </q-tab-panel>

            <q-tab-panel

              name="timetable"
            >
              <timetable ref="timetable" />
            </q-tab-panel>

            <q-tab-panel

              name="planner"
            >
              <planner ref="planner" />
            </q-tab-panel>
          </q-tab-panels>
        </template>
      </q-splitter>

      <q-separator class="q-my-lg" />

      <div class="text-center">
        <q-btn
          class="q-mb-lg"
          icon="add"
          label="Průvodce přidáním"
          @click="openGuide = true"
        />
      </div>

      <guide
        v-model="openGuide"
        @hide="hide"
      />
    </q-card>
  </background>
</template>

<script lang="ts">

import { ref } from '@vue/reactivity'

import background from '@/components/Background.vue'
import guide from '@/components/Timetable/Guide.vue'
import journey from '@/components/Timetable/Journey.vue'
import planner from '@/components/Timetable/Planner.vue'
import timetable from '@/components/Timetable/Timetable.vue'

export default {
  name: 'AdminTimetable',
  components: {
    background,
    journey,
    timetable,
    planner,
    guide
  },
  setup (): any {
    const tab = ref('journey')
    const journey = ref()
    const timetable = ref()
    const planner = ref()

    const openGuide = ref(false)

    const hide = () => {
      switch (tab.value) {
        case 'timetable':
          timetable.value.loadData()
          break
        case 'planner':
          planner.value.loadData()
          break
        case 'journey':
          journey.value.loadData()
          break
      }
    }

    return {
      tab,
      splitterModel: ref(10),
      journey,
      timetable,
      planner,
      hide,
      openGuide
    }
  }
}

</script>
